library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity communication is
  
  port (
    avs_s1_clk        : in  std_logic;
    avs_s1_reset_n    : in  std_logic;
    avs_s1_read       : in  std_logic;
    avs_s1_write      : in  std_logic;
    avs_s1_chipselect : in  std_logic;
    avs_s1_address    : in  std_logic_vector(7 downto 0);
    avs_s1_readdata   : out std_logic_vector(31 downto 0);
    avs_s1_writedata  : in  std_logic_vector(31 downto 0);

	Count0,Count1,Count2,Count3,Count4,Count5,Count6,Count7
		: in  std_logic_vector(31 downto 0);
	min0,max0,min1,max1,min2,max2,min3,max3,min4,max4,min5,max5,min6,max6,min7,max7
		: out std_logic_vector(31 downto 0)
  );

end communication;

architecture rtl of communication is

signal reset : std_logic;
signal 	rmin0,rmax0,rmin1,rmax1,rmin2,rmax2,rmin3,rmax3,rmin4,rmax4,rmin5,rmax5,rmin6,rmax6,rmin7,rmax7
		: std_logic_vector(31 downto 0);
signal	rCount0,rCount1,rCount2,rCount3,rCount4,rCount5,rCount6,rCount7
		: std_logic_vector(31 downto 0);
		
begin
reset<='0';
	min0 <= rmin0; min1 <= rmin1; min2 <= rmin2; min3 <= rmin3; min4 <= rmin4; min5 <= rmin5; min6 <= rmin6; min7 <= rmin7; 
	max0 <= rmax0; max1 <= rmax1; max2 <= rmax2; max3 <= rmax3; max4 <= rmax4; max5 <= rmax5; max6 <= rmax6; max7 <= rmax7; 	
	rCount0 <= Count0; rCount1 <= Count1; rCount2 <= Count2; rCount3 <= Count3; rCount4 <= Count4; rCount5 <= Count5; rCount6 <= Count6; rCount7 <= Count7; 

  process (avs_s1_clk)
  begin
    if avs_s1_clk'event and avs_s1_clk = '1' then
      if reset = '1' then
        avs_s1_readdata <= (others => '0');
      else
        if avs_s1_chipselect = '1' then
            if avs_s1_read = '1' then
				if		avs_s1_address="00000000" then avs_s1_readdata <=rCount0;
				elsif	avs_s1_address="00000001" then avs_s1_readdata <=rCount1;
				elsif	avs_s1_address="00000010" then avs_s1_readdata <=rCount2;
				elsif	avs_s1_address="00000011" then avs_s1_readdata <=rCount3;
				elsif	avs_s1_address="00000100" then avs_s1_readdata <=rCount4;
				elsif	avs_s1_address="00000101" then avs_s1_readdata <=rCount5;
				elsif	avs_s1_address="00000110" then avs_s1_readdata <=rCount6;
				elsif	avs_s1_address="00000111" then avs_s1_readdata <=rCount7;
				else								avs_s1_readdata <="10101010101010101010101010101010";
				end if;
            elsif avs_s1_write = '1' then
				if		avs_s1_address="00000000" then rmin0  <=avs_s1_writedata;
				elsif	avs_s1_address="00000001" then rmax0  <=avs_s1_writedata;
				elsif	avs_s1_address="00000010" then rmin1  <=avs_s1_writedata;
				elsif	avs_s1_address="00000011" then rmax1  <=avs_s1_writedata;
				elsif	avs_s1_address="00000100" then rmin2  <=avs_s1_writedata;
				elsif	avs_s1_address="00000101" then rmax2  <=avs_s1_writedata;
				elsif	avs_s1_address="00000110" then rmin3  <=avs_s1_writedata;
				elsif	avs_s1_address="00000111" then rmax3  <=avs_s1_writedata;
				elsif	avs_s1_address="00001000" then rmin4  <=avs_s1_writedata;
				elsif	avs_s1_address="00001001" then rmax4  <=avs_s1_writedata;
				elsif	avs_s1_address="00001010" then rmin5  <=avs_s1_writedata;
				elsif	avs_s1_address="00001011" then rmax5  <=avs_s1_writedata;
				elsif	avs_s1_address="00001100" then rmin6  <=avs_s1_writedata;
				elsif	avs_s1_address="00001101" then rmax6  <=avs_s1_writedata;
				elsif	avs_s1_address="00001110" then rmin7  <=avs_s1_writedata;
				elsif	avs_s1_address="00001111" then rmax7  <=avs_s1_writedata;
				end if;
            end if;
        end if;
      end if;
    end if;
  end process;

end rtl;
