library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity communication is
  
  port (
    avs_s1_clk        : in  std_logic;
    avs_s1_reset_n    : in  std_logic;
    avs_s1_read       : in  std_logic;
    avs_s1_write      : in  std_logic;
    avs_s1_chipselect : in  std_logic;
    avs_s1_address    : in  std_logic_vector(7 downto 0);
    avs_s1_readdata   : out std_logic_vector(31 downto 0);
    avs_s1_writedata  : in  std_logic_vector(31 downto 0);

	Count0,Count1,Count2,Count3,Count4,Count5,Count6,Count7
		: in  std_logic_vector(31 downto 0);
	min0,max0,min1,max1,min2,max2,min3,max3,min4,max4,min5,max5,min6,max6,min7,max7
		: out std_logic_vector(31 downto 0)
  );

end communication;

architecture rtl of communication is

signal reset : std_logic;

begin
reset<='0';
  process (avs_s1_clk)
  begin
    if avs_s1_clk'event and avs_s1_clk = '1' then
      if reset = '1' then
        avs_s1_readdata <= (others => '0');
      else
        if avs_s1_chipselect = '1' then
            if avs_s1_read = '1' then
				if		avs_s1_address="00000" then avs_s1_readdata <="10000000000000001000000000000000";
				elsif	avs_s1_address="00001" then avs_s1_readdata <=Count1;
				elsif	avs_s1_address="00010" then avs_s1_readdata <=Count2;
				elsif	avs_s1_address="00011" then avs_s1_readdata <=Count3;
				elsif	avs_s1_address="00100" then avs_s1_readdata <=Count4;
				elsif	avs_s1_address="00101" then avs_s1_readdata <=Count5;
				elsif	avs_s1_address="00110" then avs_s1_readdata <=Count6;
				elsif	avs_s1_address="00111" then avs_s1_readdata <=Count7;
				else								avs_s1_readdata <="10101010101010101010101010101010";
				end if;
            elsif avs_s1_write = '1' then
				min0  <=avs_s1_writedata;
            end if;
        end if;
      end if;
    end if;
  end process;

end rtl;
