library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



entity histo is port (
	clk			: in  std_logic; --50MHz
	R			: in  std_logic_vector(9 downto 0);
	G			: in  std_logic_vector(9 downto 0);
	B			: in  std_logic_vector(9 downto 0);
	new_pixel	: in  std_logic;
	new_frame	: in  std_logic;
	Min			: in  std_logic_vector(31 downto 0);
	Max			: in  std_logic_vector(31 downto 0);
	count		: out std_logic_vector(31 downto 0) );
end histo;

architecture rtl of histo is

signal zero : std_logic;
signal counter,counter2 : std_logic_vector(31 downto 0);
signal RedMin,RedMax,GreenMin,GreenMax,BlueMin,BlueMax : std_logic_vector(9 downto 0);
begin

	count <= counter2;
	RedMin	<= Min(29 downto 20);
	GreenMin<= Min(19 downto 10);
	BlueMin	<= Min( 9 downto  0);
	RedMax	<= Max(29 downto 20);
	GreenMax<= Max(19 downto 10);
	BlueMax	<= Max( 9 downto  0);

	
	process (clk)
	begin
		if clk'event and clk='1' then
			if new_frame='0' and zero='1' then
				zero	<='0';	
				counter <= "00000000000000000000000000000000";
			end if;
			
			if new_frame='1' then
				counter2 <= counter;
				zero	<='1';
			end if;
			
			if new_pixel='1' then
				if 	R >= RedMin and R<=RedMax and
					G >= GreenMin and G<=GreenMax and
					B >= BlueMin and B<=BlueMax then
					counter <= counter+1;
				end if;
			end if;
		end if;
	end process;
	
end rtl;